unit uMakeDirUI;
{$INCLUDE 'Plugin.inc'}

interface

uses
  Windows, SysUtils, Classes,
  {$INCLUDE 'DelphiFarUnits.inc'} ;

type
  TMakeDirDialog = class(TOkCancelDialog)
  private
    fName: string;
  private
    fEditName: TFarDialog.TEdit;
  protected
    procedure Clear; override;
    procedure CreateUserControls; override;
    procedure SetSize(Width, Height: Integer); override;
    procedure ConsoleSizeToDialogSize(var Width, Height: Integer); override;
    property EditName: TFarDialog.TEdit read fEditName;
  public
    class function ExecuteDialog(var Name: string): boolean;
    constructor Create;
    destructor Destroy; override;
    function Execute: boolean;
    property Name: string read fName write fName;
  end;

implementation

uses
  uMessages, uPluginConsts;

{ TMakeDirDialog }

procedure TMakeDirDialog.Clear;
begin
  inherited;
  fEditName := nil;
end;

constructor TMakeDirDialog.Create;
begin
  inherited Create(DIALOG_MAKEDIR_GUID);
end;

procedure TMakeDirDialog.CreateUserControls;
begin
  inherited;
  fEditName := AddEdit(0, 0, 0, '');
  fEditName.History := HISTORY_NAME;
end;

destructor TMakeDirDialog.Destroy;
begin
  inherited;
end;

function TMakeDirDialog.Execute: boolean;
begin
  Result := False;
  EditName.Text := Name;
  if inherited Execute then
  begin
    Name := EditName.Text;
    Result := True;
  end;
end;

class function TMakeDirDialog.ExecuteDialog(var Name: string): boolean;
var
  Dialog: TMakeDirDialog;
begin
  Dialog := TMakeDirDialog.Create;
  try
    Dialog.Name := Name;
    Result := Dialog.Execute;
    if Result then
      Name := Dialog.Name;
  finally
    FreeAndNil(Dialog);
  end;
end;

procedure TMakeDirDialog.SetSize(Width, Height: Integer);
begin
  inherited;
  AutoPos(EditName);
end;

procedure TMakeDirDialog.ConsoleSizeToDialogSize(var Width, Height: Integer);
begin
  inherited;
  Height := 7;
end;

end.
